registerOutputEvent(Player, "setVariable", "string 32 100\tstring 32 100 1",1);
registerOutputEvent(Player, "addVariable", "string 32 100\tstring 32 100 1",1);
registerOutputEvent(Player, "multiplyVariable", "string 32 100\tstring 32 100 0",1);
registerOutputEvent(Player, "divideVariable", "string 32 100\tstring 32 100",1);
registerOutputEvent(GameConnection, "setVariable", "string 32 100\tstring 200 100",1);
registerOutputEvent(GameConnection, "addVariable", "string 32 100\tstring 32 100",1);
registerOutputEvent(GameConnection, "multiplyVariable", "string 32 100\tstring 32 100",1);
registerOutputEvent(GameConnection, "divideVariable", "string 32 100\tstring 32 100",1);
registerOutputEvent(GameConnection, "displayVariable", "list Player 0 Client 1\tlist ChatMessage 1 CenterPrint 2 BottomPrint 3 MessageBoxOK 4\tint 1 10 3\tstring 32 100",1);
registerOutputEvent(fxDTSBrick, "setVariable", "string 32 100\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "addVariable", "string 32 100\tstring 32 100",1);
registerOutputEvent(fxDTSBrick, "multiplyVariable", "string 32 100\tstring 32 100",1);
registerOutputEvent(fxDTSBrick, "divideVariable", "string 32 100\tstring 32 100",1);
registerOutputEvent(fxDTSBrick, "addVarToVar", "list Player 0 Client 1 Brick 2\tString 32 100\tlist Player 0 Client 1 Brick 2\tstring 32 100");
registerOutputEvent(fxDTSBrick, "subVarFromVar", "list Player 0 Client 1 Brick 2\tString 32 100\tlist Player 0 Client 1 Brick 2\tstring 32 100");
registerOutputEvent(fxDTSBrick, "setVarToVar", "list Player 0 Client 1 Brick 2\tString 32 100\tlist Player 0 Client 1 Brick 2\tstring 32 100");
registerOutputEvent(fxDTSBrick, "displayVariable", "list ChatMessage 1 CenterPrint 2 BottomPrint 3 MessageBoxOK 4\tint 1 10 3\tstring 32 100",1);
registerOutputEvent(fxDTSBrick, "ifVariable", "list Player 0 Client 1 Brick 2\tstring 32 100\tlist Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "ifVarToVar", "list Player 0 Client 1 Brick 2\tstring 32 100\tlist Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tlist Player 0 Client 1 Brick 2\tstring 32 100",1);
registerOutputEvent(fxDTSBrick, "ifBrickNameEquals", "string 32 200",1);
registerOutputEvent(fxDTSBrick, "ifPrintCount", "list Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "ifAdmin", "",1);
registerOutputEvent(fxDTSBrick, "ifPlayerNameEquals", "string 32 200",1);
registerOutputEvent(fxDTSBrick, "ifPlayerID", "list Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "ifPlayerScore", "list Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "ifPlayerDamage", "list Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "ifPlayerEnergy", "list Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "ifPlayerSpeed", "list X 1 Y 2 Z 3\tlist Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "ifLastPlayerMsg", "string 200 100",1);
registerOutputEvent(fxDTSBrick, "ifRandomDice", "string 32 100\tlist Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "ifRandom", "string 32 100\tstring 32 100\tlist Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tstring 200 100",1);
registerInputEvent(fxDTSBrick, "VariableTrue", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);
registerInputEvent(fxDTSBrick, "VariableFalse", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);
function fxDTSBrick::VariableTrue(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("VariableTrue", %client);
}

function fxDTSBrick::VariableFalse(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("VariableFalse", %client);
}

function GameConnection::displayVariable(%this,%cp,%method,%printtime,%variable,%client)
{
	%target = %cp ? %this:%this.player;
	switch$ (%method)
	{
		case 1:
			messageClient(%this,'MsgDisplayVariable','<color:ffffff>%1 is %2',%variable,%target.var[%variable]);
		case 2:
			commandtoclient(%this,'centerprint',"<color:ffffff>" @ %variable @ " is " @ %target.var[%variable],%printtime);
		case 3:
			commandtoclient(%this,'bottomprint',"<color:ffffff>" @ %variable @ " is " @ %target.var[%variable],%printtime);
		case 4:
			commandtoclient(%this,'MessageBoxOK',"Variable", %variable @ " is " @ %target.var[%variable]);
	}
}

function fxDtsBrick::displayVariable(%this,%method,%printtime,%variable,%client)
{
	switch$ (%method)
	{
		case 1:
			messageClient(%client,'MsgDisplayVariable','<color:ffffff>Brick\'s %1 is %2',%variable,%this.var[%variable]);
		case 2:
			commandtoclient(%client,'centerprint',"<color:ffffff>Brick's " @ %variable @ " is " @ %this.var[%variable],%printtime);
		case 3:
			commandtoclient(%client,'bottomprint',"<color:ffffff>Brick's " @ %variable @ " is " @ %this.var[%variable],%printtime);
		case 4:
			commandtoclient(%client,'MessageBoxOK',"Variable", "Brick's " @ %variable @ " is " @ %this.var[%variable]);
	}
}
function fxDTSBrick::ifVariable(%this,%cpb,%variable,%logic,%amount,%client)
{
	if(%cpb == 2)
		%target = %this;
	else
		%target = %cpb ? %client:%client.player;
	%flag = false;
	switch$ (%logic)
	{
		case 1:
			%idc = %target.var[%variable] $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 2:
			%idc = %target.var[%variable] !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 3:
			%idc = %target.var[%variable] > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 4:
			%idc = %target.var[%variable] < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 5:
			%idc = %target.var[%variable] >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 6:
			%idc = %target.var[%variable] <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
	}
}

function fxDTSBrick::ifVarToVar(%this,%tcpb,%tvar,%logic,%ccpb,%cvar,%client)
{
	if(%tcpb == 2)
		%target = %this;
	else
		%target = %tcpb ? %client:%client.player;
	if(%ccpb == 2)
		%comparison = %this;
	else
		%comparison = %ccpb ? %client:%client.player;
	%flag = false;
	switch$ (%logic)
	{
		case 1:
			%idc = %target.var[%tvar] $= %comparison.var[%cvar] ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 2:
			%idc = %target.var[%tvar] !$= %comparison.var[%cvar] ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 3:
			%idc = %target.var[%tvar] > %comparison.var[%cvar] ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 4:
			%idc = %target.var[%tvar] < %comparison.var[%cvar] ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 5:
			%idc = %target.var[%tvar] >= %comparison.var[%cvar] ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 6:
			%idc = %target.var[%tvar] <= %comparison.var[%cvar] ? %this.variableTrue(%client):%this.variableFalse(%client);
	}
}

function fxDTSBrick::ifBrickNameEquals(%this,%name,%client)
{
   %test = getsubstr(%this.getname(),1,strlen(%this.getname()));
   if(%test $= %name)
   {
      %this.variableTrue(%client);
      return;
   }
   else if(%test != %name)
   {
      %this.variableFalse(%client);
      return;
   }
}

function fxDTSBrick::ifPrintCount(%this,%logic,%amount,%client)
{
	switch$ (%logic)
	{
		case 1:
			%idc = %this.printCount $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 2:
			%idc = %this.printCount !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 3:
			%idc = %this.printCount > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 4:
			%idc = %this.printCount < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 5:
			%idc = %this.printCount >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 6:
			%idc = %this.printCount <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
	}
}

function fxDTSBrick::ifAdmin(%this,%client)
{
   if(%client.isAdmin == 1 | %client.isSuper == 1)
   {
      %this.variableTrue(%client);
      return;
   }
   else if(%client.isAdmin == 0 | %client.isSuper == 0)
   {
      %this.variableFalse(%client);
      return;
   }
}

function fxDTSBrick::ifLastPlayerMsg(%this,%msg,%client)
{
   if(%client.lastChatText $= %msg)
   {
      %this.variableTrue(%client);
   }
   else
   {
      %this.variableFalse(%client);
   }
}

function fxDTSBrick::ifPlayerNameEquals(%this,%name,%client)
{
   if(%client.name $= %name)
   {
      %this.variableTrue(%client);
      return;
   }
   else
   {
      %this.variableFalse(%client);
      return;
   }
}

function fxDTSBrick::ifPlayerSpeed(%this,%type,%logic,%amount,%client)
{
	switch$ (%type)
	{
		case 1:
			%speed = getWord(%client.player.getVelocity(),0);
		case 2:
			%speed = getWord(%client.player.getVelocity(),1);
		case 3:
			%speed = getWord(%client.player.getVelocity(),2);
	}
	switch$ (%logic)
	{
		case 1:
			%idc = %speed $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 2:
			%idc = %speed !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 3:
			%idc = %speed > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 4:
			%idc = %speed < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 5:
			%idc = %speed >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 6:
			%idc = %speed <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
	}
}

function fxDTSBrick::ifPlayerID(%this,%logic,%amount,%client)
{
  %target = %client;
	switch$ (%logic)
	{
		case 1:
			%idc = %target.BL_ID $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 2:
			%idc = %target.BL_ID !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 3:
			%idc = %target.BL_ID > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 4:
			%idc = %target.BL_ID < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 5:
			%idc = %target.BL_ID >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 6:
			%idc = %target.BL_ID <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
	}
}

function fxDTSBrick::ifPlayerScore(%this,%logic,%amount,%client)
{
  %target = %client;
	switch$ (%logic)
	{
		case 1:
			%idc = %target.score $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 2:
			%idc = %target.score !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 3:
			%idc = %target.score > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 4:
			%idc = %target.score < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 5:
			%idc = %target.score >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 6:
			%idc = %target.score <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
	}
}

function fxDTSBrick::ifPlayerDamage(%this,%logic,%amount,%client)
{
  %target = %client;
	switch$ (%logic)
	{
		case 1:
			%idc = %target.player.getDamageLevel() $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 2:
			%idc = %target.player.getDamageLevel() !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 3:
			%idc = %target.player.getDamageLevel() > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 4:
			%idc = %target.player.getDamageLevel() < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 5:
			%idc = %target.player.getDamageLevel() >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 6:
			%idc = %target.player.getDamageLevel() <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
	}
}

function fxDTSBrick::ifPlayerEnergy(%this,%logic,%amount,%client)
{
  %target = %client;
	switch$ (%logic)
	{
		case 1:
			%idc = %target.player.getEnergyLevel() $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 2:
			%idc = %target.player.getEnergyLevel() !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 3:
			%idc = %target.player.getEnergyLevel() > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 4:
			%idc = %target.player.getEnergyLevel() < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 5:
			%idc = %target.player.getEnergyLevel() >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
		case 6:
			%idc = %target.player.getEnergyLevel() <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
	}
}

function fxDTSBrick::ifRandomDice(%this,%sides,%logic,%amount,%client)
{
   %randomroll = getRandom(0,%sides);
   switch$ (%logic)
   {
      case 1:
  	 %idc = %randomroll $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 2:
	   %idc = %randomroll !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 3:
   	%idc = %randomroll > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 4:
  	%idc = %randomroll < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 5:
   	%idc = %randomroll >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 6:
   	%idc = %randomroll <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
   }
}

function fxDTSBrick::ifRandom(%this,%ama,%amb,%logic,%amount,%client)
{
   %random = getRandom(%ama,%amb);
   switch$ (%logic)
   {
      case 1:
  	 %idc = %random $= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 2:
	   %idc = %random !$= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 3:
   	%idc = %random > %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 4:
  	%idc = %random < %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 5:
   	%idc = %random >= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
      case 6:
   	%idc = %random <= %amount ? %this.variableTrue(%client):%this.variableFalse(%client);
   }
}

function Player::SetVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable] = %amount;
}

function Player::addVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable]+=%amount;
}

function Player::multiplyVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable]*=%amount;
}

function Player::divideVariable(%player,%variable,%amount,%client)
{
	if(%amount != 0)
		%player.var[%variable]/=%amount;
}

function GameConnection::SetVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable] = %amount;
}

function GameConnection::addVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable]+=%amount;
}

function GameConnection::multiplyVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable]*=%amount;
}

function GameConnection::divideVariable(%player,%variable,%amount,%client)
{
	if(%amount != 0)
		%player.var[%variable]/=%amount;
}

function fxDtsBrick::SetVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable] = %amount;
}

function fxDtsBrick::addVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable]+=%amount;
}

function fxDtsBrick::multiplyVariable(%player,%variable,%amount,%client)
{
	%player.var[%variable]*=%amount;
}

function fxDtsBrick::divideVariable(%player,%variable,%amount,%client)
{
	if(%amount != 0)
		%player.var[%variable]/=%amount;
}

function fxDtsBrick::addVarToVar(%this,%tpcb,%tvar,%opcb,%ovar,%client)
{
	if(%tpcb == 2)
		%target = %this;
	else
		%target = %tpcb ? %client:%client.player;
	if(%opcb == 2)
		%other = %this;
	else
		%other = %opcb ? %client:%client.player;
	%target.var[%tvar]+=%other.var[%ovar];
}

function fxDtsBrick::subVarFromVar(%this,%tpcb,%tvar,%opcb,%ovar,%client)
{
	if(%tpcb == 2)
		%target = %this;
	else
		%target = %tpcb ? %client:%client.player;
	if(%opcb == 2)
		%other = %this;
	else
		%other = %opcb ? %client:%client.player;
	%target.var[%tvar]-=%other.var[%ovar];
}

function fxDtsBrick::setVarToVar(%this,%tpcb,%tvar,%opcb,%ovar,%client)
{
	if(%tpcb == 2)
		%target = %this;
	else
		%target = %tpcb ? %client:%client.player;
	if(%opcb == 2)
		%other = %this;
	else
		%other = %opcb ? %client:%client.player;
	%target.var[%tvar]=%other.var[%ovar];
}